#include <gtk/gtk.h>

static void 
on_button_clicked (GtkButton *button, gpointer data)
{
	GObject     *window;
	GtkLabel    *label;
	GtkEntry    *entry;
	const gchar *text;
	
	window = G_OBJECT (data);
	
	label = GTK_LABEL (g_object_get_data (window, "label"));
	entry = GTK_ENTRY (g_object_get_data (window, "text_entry"));

	text = gtk_entry_get_text (entry);
	
/*	gtk_label_set_text (label, text); */
}

static void
on_entry_changed (GtkEditable *editable, GtkWidget *button)
{
	const gchar *text;
	const gchar *start;
	gboolean has_text;

	text = gtk_entry_get_text (GTK_ENTRY (editable));

	start = text;
	while (*start != '\0' && g_ascii_isspace (*start))
		start ++;

	has_text = (start && start[0]);
	
	gtk_widget_set_sensitive (button, has_text);
}

GtkWidget *
construct_window (void)
{
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *text_entry;

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "ejemplo");

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);
	gtk_container_add (GTK_CONTAINER (window), vbox);

	hbox = gtk_hbox_new (FALSE, 10);
	
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 10);

	text_entry = gtk_entry_new ();
	gtk_box_pack_start (GTK_BOX (hbox), text_entry, TRUE, TRUE, 0);

	button = gtk_button_new_from_stock (GTK_STOCK_APPLY);
	gtk_widget_set_sensitive (button, FALSE);
	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
	
	label = gtk_label_new ("ejemplo");
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

	g_object_set_data (G_OBJECT (window), "label", label);
	g_object_set_data (G_OBJECT (window), "text_entry", text_entry);

	g_signal_connect (G_OBJECT (button), "clicked", 
			  G_CALLBACK (on_button_clicked), window);
	
	g_signal_connect (G_OBJECT (text_entry), "changed", 
			  G_CALLBACK (on_entry_changed), button);
	return window;
}
int
main (gint argc, gchar **argv)
{
	gtk_init (&argc, &argv);
	GtkWidget *window = construct_window ();

	gtk_widget_show_all (window);
	g_signal_connect (G_OBJECT (window), "delete-event", 
			  gtk_main_quit, NULL);

	gtk_main ();
	
	return 0;
}
